/*
Название: StepAndCopy.jsx
Приложение для использования: Adobe InDesign CS3, CS4
Версия: 1.0
Язык реализации (Среда): JavaScript (ExtendScript Toolkit 2)
Операционные системы (Платформы): PC, Macintosh (Windows, Mac OS)
Условия распространения: Бесплатно; На Ваш риск
Назначение: Перемещение и копирование выделенных объектов
Функциональные ограничения: Не работает с направляющими
Техническая поддержка: Sergey-Anosov@yandex.ru
===================================================
Name: StepAndCopy.jsx
Application to use with: Adobe InDesign CS3, CS4
Version: 1.0
Program language (Environment): JavaScript (ExtendScript Toolkit 2)
Operating systems (Platforms): PC, Macintosh (Windows, Mac OS)
Distribution terms: Freeware; At your own risk
Destination: Moving and duplicating of selected objects
Functional limitations: Can not process selected guides
Technical support: Sergey-Anosov@yandex.ru
*/
var SCRIPT_TITLE = "Step and Copy ";
var VERSION = "v.1.0";
var AD, the_sel, sel_len, old_rulers;
var RULERS_WERE_CHANGED = false;
var dialog_main, dialog_main_bounds;
var DIALOG_OLD = false;
var GT, GL, GB, GR, GCH, GCV, VT, VL, VB, VR, VCH, VCV;
var T_VALUE = false, B_VALUE = false, L_VALUE = false, R_VALUE = false;
var TL_VALUE = false, TR_VALUE = false, BL_VALUE = false, BR_VALUE = false, CC_VALUE = true;
var H;// width
var V;// height
var V_NUM, H_NUM;
var GEO_BOUNDS, GEO_BOUNDS_VALUE = true;
var VIZ_BOUNDS, VIZ_BOUNDS_VALUE = false;
var REL_C, REL_C_VALUE = true;
var G_OBJ_L, G_OBJ_R, G_OBJ_T, G_OBJ_B;
var V_OBJ_L, V_OBJ_R, V_OBJ_T, V_OBJ_B;
var GH, GV, VH, VV;
var H_UNITS_TEXT = "??";
var V_UNITS_TEXT = "??";
var H_STEP = 0.;
var V_STEP = 0.;
var COPY_BUTTON, COPY_BUTTON_VALUE = false;
var P_S = "+0";
var M_S = "-0";
var V_STEP_TEXT = P_S;
var H_STEP_TEXT = P_S;
var LOCKED = false;
var N_STEP = 1;
var N_STEP_DONE = 0;
var STEPS;
//
// основной блок
SET_VERSION();
CHECK_SELECTION();
GET_SEL_BOUNDS();
DIALOG();
RESTORE_PREFS();
exit();
//
// подпрограмма создания и вывода диалога
function DIALOG(){
	dialog_main = new Window('dialog');
	//dialog_main.independent = true;
	if( DIALOG_OLD) dialog_main.location = dialog_main_bounds;
	dialog_main.text = SCRIPT_TITLE + VERSION;
	dialog_main.orientation = 'column';
	// верхняя группа
	var top_group = dialog_main.add('group');
	top_group.alignChildren = 'top';
	top_group.orientation = 'row';
	// группа для выбора направлений (слева)
	var dir_group = top_group.add('group');
	dir_group.orientation = 'column';
	dir_group.alignChildren = 'left';
	var dir_pan =  dir_group.add('panel');
	dir_pan.bounds = [0, 0, 100, 100];
	var dir_dx = 30;
	var dir_dy = 30;
	var dir_x0 = 8;
	var dir_y0 = 3;
	// подпрограмма создания кнопок для выбора направлений
	function RB_xy(x, y) {
		var the_rb = dir_pan.add('radiobutton');
		var d = 30
		the_rb.bounds = [x, y, x+d, y+d];
		the_rb.onClick = BOUNDS_ON_CLICK;
		return the_rb;
	}// end RB_xy
	// верх-лево, верх, верх-право
	var TL = RB_xy(dir_x0, dir_y0); TL.value = TL_VALUE;
	var T = RB_xy(dir_x0+dir_dx, dir_y0); T.value = T_VALUE;
	var TR = RB_xy(dir_x0+dir_dx*2, dir_y0); TR.value = TR_VALUE;
	// лево, центр, право
	dir_y0 = dir_y0 +dir_dy;
	var L = RB_xy(dir_x0, dir_y0); L.value = L_VALUE;
	var C = RB_xy(dir_x0+dir_dx, dir_y0); C.value = CC_VALUE;
	var R = RB_xy(dir_x0+dir_dx*2, dir_y0); R.value = R_VALUE;
	// низ-лево, низ, низ-право
	dir_y0 = dir_y0 +dir_dy;
	var BL = RB_xy(dir_x0, dir_y0); BL.value = BL_VALUE;
	var B = RB_xy(dir_x0+dir_dx, dir_y0); B.value = B_VALUE;
	var BR = RB_xy(dir_x0+dir_dx*2, dir_y0); BR.value = BR_VALUE;
	// относительный центр
	REL_C =  dir_group.add('checkbox');
	REL_C.text = 'Relative center';
	REL_C.value = REL_C_VALUE;
	REL_C.onClick = BOUNDS_ON_CLICK;
	// применить к копии
	COPY_BUTTON = dir_group.add('checkbox');
	COPY_BUTTON.text = 'Apply to copy';
	COPY_BUTTON.value = COPY_BUTTON_VALUE;
	//
	// группа опций (панель справа)
	var OPT_GROUP =  top_group.add('panel');
	OPT_GROUP.orientation = 'column';
	OPT_GROUP.alignChildren = 'center';
	//
	// самая верхняя группа (все кроме ОК-Cancel)
	var TOP_GROUP = OPT_GROUP.add('group');
	TOP_GROUP.orientation = 'row';
	TOP_GROUP.alignChildren = 'top';
	//
	// колонка 1 (самая левая): выбор границ, координаты
	var OPT_COLUMN_1 = TOP_GROUP.add('group');
	OPT_COLUMN_1.orientation = 'column';
	OPT_COLUMN_1.alignChildren = 'left';
	// геометр. или виз. границы
	var BOUNDS_GROUP =OPT_COLUMN_1.add('group');
	BOUNDS_GROUP.orientation = 'column';
	BOUNDS_GROUP.alignChildren = 'left';
	GEO_BOUNDS = BOUNDS_GROUP.add('radiobutton');
	GEO_BOUNDS.text = "Geometric bounds";
	GEO_BOUNDS.value = GEO_BOUNDS_VALUE;
	GEO_BOUNDS.onClick = BOUNDS_ON_CLICK;
	VIZ_BOUNDS = BOUNDS_GROUP.add('radiobutton');
	VIZ_BOUNDS.text = "Visible bounds";
	VIZ_BOUNDS.value = VIZ_BOUNDS_VALUE;
	VIZ_BOUNDS.onClick = BOUNDS_ON_CLICK;
	// группа вывода координат
	// подпрограмма вывода текстового блока в диалоге
	function TEXT(obj, text_type, the_text, len) {
		var T = obj.add(text_type);
		T.text = the_text;
		T.size = [len, 18];
	return T;
	};
	var COORD_GROUP = 	OPT_COLUMN_1.add('group');
	COORD_GROUP.orientation = 'row';
	//COORD_GROUP.alignChildren = 'top';
	// выводим координаты
	var COORD_GROUP_1 =COORD_GROUP.add('group');
	COORD_GROUP_1.orientation = 'column';
	COORD_GROUP_1.alignChildren = 'left';
	H_NUM = TEXT(COORD_GROUP_1, 'statictext', " ", 140);
	V_NUM = TEXT(COORD_GROUP_1, 'statictext', " ", 140);
	// колонка 1 построена
	//
	//колонка 2 (самая правая): выбор количества шагов, смещения
	var OPT_COLUMN_2 = TOP_GROUP.add('group');
	OPT_COLUMN_2.orientation = 'column';
	OPT_COLUMN_2.alignChildren = 'right';
	// группа шагов
	var STEPS_GROUP = OPT_COLUMN_2.add('group');
	STEPS_GROUP.orientation = 'column';
	STEPS_GROUP.alignChildren = 'left';
	// ввод количества шагов
	var STEP_INPUT = STEPS_GROUP.add('group');
	STEP_INPUT.orientation = 'row';
	var STEPS_TEXT = TEXT(STEP_INPUT, 'statictext',"Steps:", 40);
	STEPS = TEXT(STEP_INPUT, 'edittext', N_STEP.toString(), 30);
	// вывод уже сделанных шагов
	var STEP_DONE = STEPS_GROUP.add('group');
	STEP_DONE.orientation = 'row';
	var N_S_DONE = TEXT(STEP_DONE, 'statictext', ("Done:    "+N_STEP_DONE.toString()), 70);
	// группа смещений по вертикали и горизонтали
	var COORD_GROUP_2 = OPT_COLUMN_2.add('group');
	COORD_GROUP_2.orientation = 'column';
	COORD_GROUP_2.alignChildren = 'left';
	// ввод смещений
	var H_GROUP = COORD_GROUP_2.add('group');
	// X (H)
	H_GROUP.orientation = 'row';
	H_GROUP.alignChildren = 'top';
	var dX_TEXT = TEXT(H_GROUP, 'statictext', "dX:", 20);
	H_STEP = TEXT(H_GROUP, 'edittext', H_STEP_TEXT, 60);
	// Y (V)
	var V_GROUP = COORD_GROUP_2.add('group');
	V_GROUP.orientation = 'row';
	V_GROUP.alignChildren = 'top';
	var dY_TEXT = TEXT(V_GROUP, 'statictext', "dY:", 20);
	V_STEP = TEXT(V_GROUP, 'edittext', V_STEP_TEXT, 60);
	// обновляем значения в окошках
	BOUNDS_ON_CLICK();
	// кнопки ОК или выход
	var OK_group = OPT_GROUP.add('group');
	OK_group.orientation = 'row';
	var okBtn = OK_group.add('button', undefined, 'OK');// кнопка ОК
	var cancelBtn = OK_group.add('button', undefined, 'Cancel');// кнопка Cancel
	//
	// подпрограмма перемещения объектов
	function MOVE( ) {
	DIALOG_OLD = true;
	COPY_BUTTON_VALUE = COPY_BUTTON.value;
	DUPLICATE = COPY_BUTTON_VALUE;
	REL_C_VALUE = REL_C.value;
	GEO_BOUNDS_VALUE = GEO_BOUNDS.value;
	VIZ_BOUNDS_VALUE = VIZ_BOUNDS.value;
	N_STEP = parseInt( GET_NUMBER(STEPS.text) );
	if( N_STEP < 1 ) {
		alert("Warning:\nBad number of steps! The "+'"'+"1"+'"'+" is assigned!");
		N_STEP = 1;
	};
	for( var st = 1; st <= N_STEP; st++ ) {
	if( LOCKED && !DUPLICATE ) {
		if( !confirm("Warning:\nSome of the objects to be moved are locked!\nUnlock and continue?") ) {
			RESTORE_PREFS();
			exit();
		}
	}
	var D;
	// рассчитываем перемещения
	H_STEP_TEXT = H_STEP.text;
	V_STEP_TEXT = V_STEP.text;
	var D_H_X = GET_NUMBER(H_STEP_TEXT);
	var D_V_Y = GET_NUMBER(V_STEP_TEXT);
	// если относительный центр
	if( REL_C_VALUE ) {
		D_H_X = H + D_H_X;
		D_V_Y = V + D_V_Y;
	};// if
	var the_obj = new Array();
	the_obj = the_sel;
	if( DUPLICATE ) app.selection = null;
	for( var i=0; i < the_obj.length; i++ ) {
		if( DUPLICATE ) {
			D = the_obj[i].duplicate();
			D.select( SelectionOptions.addTo );
		} else {
			D = the_obj[i];
		};// if-else
		if( LOCKED ) {
			try {
				D.locked = false ;
			} catch( error ) {
				if( !UNLOCK_PARENT( D )) EXIT_MESSAGE("Can not do this!");
			};// try-catch
		};// if
		try {
			D.move(undefined, [D_H_X, D_V_Y]);
		} catch (error) {
			EXIT_MESSAGE("Can not do this!");
		};// try-catch
	};// for i
	N_STEP_DONE = N_STEP_DONE + 1;
	GET_SEL_BOUNDS();
	};// for st
	BOUNDS_ON_CLICK();
	DIALOG();
	return;
	};// end MOVE
	//
	// подпрограмма разблокирования фрейма или группы
	function UNLOCK_PARENT(OBJ){
		var the_object, the_parent, the_name;
		var MAX = 1000000;
		var N = 0;
		the_object = OBJ;
		do {
			N = N +1;
			if( N > MAX ) return false;
			try{ 
				the_parent = the_object.parent;
				the_name = the_parent.constructor.name;
				if(!(the_name == "Rectangle" || the_name == "Oval" || the_name == "Polygon" || the_name == "Group")) break;
				the_object = the_parent;
			} catch( error ) { 
				return false;
			};// try-catch
		} while (true);
		try {
			the_object.locked = false;
		} catch( error ) {
			return false;
		};// try-catch
		return true;
	};// end UNLOCK_PARENT
	//
	// подпрограмма измения параметров вывода в диалоге
	// при изменении введенных опций
	function DIR_ON_CHANGE () {
		if( TL.value ) {H_STEP_TEXT = M_S; V_STEP_TEXT = M_S }
		if( T.value ) {H_STEP_TEXT = P_S; V_STEP_TEXT = M_S }
		if( TR.value ) {H_STEP_TEXT = P_S; V_STEP_TEXT = M_S }
		
		if( L.value ) {H_STEP_TEXT = M_S; V_STEP_TEXT = P_S }
		if( C.value ) {H_STEP_TEXT = P_S; V_STEP_TEXT = P_S }
		if( R.value ) {H_STEP_TEXT = P_S; V_STEP_TEXT = P_S }
		
		if( BL.value ) {H_STEP_TEXT = M_S; V_STEP_TEXT = P_S }
		if( B.value ) {H_STEP_TEXT = P_S; V_STEP_TEXT = P_S }
		if( BR.value ) {H_STEP_TEXT = P_S; V_STEP_TEXT = P_S }
		
		H_STEP.text = H_STEP_TEXT;
		V_STEP.text = V_STEP_TEXT;
		
		T_VALUE = T.value, B_VALUE = B.value, L_VALUE =L.value, R_VALUE = R.value;
		TL_VALUE = TL.value, TR_VALUE = TR.value, BL_VALUE = BL.value, BR_VALUE = BR.value;
		CC_VALUE = C.value;

	return;
	}// end DIR_ON_CHANGE;
	//
	// подпрограмма реакции на нажатие кнопок опций в диалоге
	function BOUNDS_ON_CLICK() {
		var ABS_T, ABS_L, ABS_B, ABS_R, ABS_CV, ABS_CH;
		if( TL.value != TL_VALUE || T.value != T_VALUE || TR.value != TR_VALUE ||
			 L.value != L_VALUE || C.value != CC_VALUE || R.value != R_VALUE ||
			 BL.value != BL_VALUE || B.value != B_VALUE || BR.value != BR_VALUE) DIR_ON_CHANGE ();
		// если нет относительных границ
		if( !REL_C.value ) {
			if( GEO_BOUNDS.value ) { ABS_L = GL; ABS_B = GB; ABS_R = GR; ABS_T = GT; ABS_CH = GCH; ABS_CV = GCV };
			if( VIZ_BOUNDS.value ) { ABS_L = VL; ABS_B = VB; ABS_R = VR; ABS_T = VT; ABS_CH = VCH; ABS_CV = VCV };
			
			if( TL.value || L.value || BL.value ) { H = ABS_L; /*H_STEP_TEXT = M_S*/ };
			if( T.value || C.value || B.value )  H = ABS_CH;
			if( TR.value || R.value || BR.value ) H = ABS_R;
			
			if( TL.value || T.value || TR.value ) { V = ABS_T; /*V_STEP_TEXT = M_S */};
			if( L.value || C.value || R.value ) V = ABS_CV;
			if( BL.value || B.value || BR.value ) V = ABS_B;
		} else {
		// если есть относительные границы
			if( GEO_BOUNDS.value ) {
				H = GH;
				V = GV;
			}
			if( VIZ_BOUNDS.value ) {
				H = VH;
				V = VV;
			}
			if( TL.value || L.value || BL.value ) { H = -1*H };
			if( TL.value || T.value || TR.value ) { V = -1*V };
			if( R.value || C.value || L.value ) V = 0.;
			if( T.value || C.value || B.value ) H = 0.;
		}// else
		H_STEP.text = H_STEP_TEXT;
		V_STEP.text = V_STEP_TEXT;
		var H_SHOW = H.toFixed(3);
		var V_SHOW = V.toFixed(3);
		H_NUM.text = "H (X): "+ H_SHOW + " "+H_UNITS_TEXT;
		V_NUM.text = "V (Y): "+V_SHOW+ " "+V_UNITS_TEXT;
	return;
	}
	//
	//
	var DIALOG_BUTTON = dialog_main.show();
	dialog_main_bounds = dialog_main.location;
	if( DIALOG_BUTTON == 1 ) MOVE();
} // end DIALOG
//
// подпрограмма определения единиц для линеек документа
function GET_RULER_UNITS_TEXT(the_units) {
	switch ( the_units ) {
		case (2054188905): return "pt";// points
		case (2054187363): return "pc";// picas
		case (2053729891): return "in";// inches
		case (2053729892): return "ind";// in chesdecimal
		case (2053991795): return "mm";
		case (2053336435): return "cm";
		case (2053335395): return "ci";// ciceros
		case (1131639917): return "pt";// custom
		case (2051106676): return "ag";// agates
		default: return "??";
	}// switch
return "??";
}// GET_RULER_UNITS_TEXT;
//
// подпрограмма получения границ выделения
function GET_SEL_BOUNDS() {
	var VT_OUT, VL_OUT, VB_OUT, VR_OUT, GT_OUT, GL_OUT, GB_OUT, VR_OUT;
	//AD.zeroPoint  = [0., 0.];
	try {
		AD = app.activeDocument;
		the_sel = app.selection;
		sel_len = the_sel.length;
		H_UNITS_TEXT = GET_RULER_UNITS_TEXT(AD.viewPreferences.horizontalMeasurementUnits);
		V_UNITS_TEXT = GET_RULER_UNITS_TEXT(AD.viewPreferences.verticalMeasurementUnits);
		SAVE_PREFS();
		var the_sel_i = the_sel[0] ;
		// получаем границы веделения
		// начальное присвоение
		GT_OUT = the_sel_i.geometricBounds[0];
		VT_OUT = the_sel_i.visibleBounds[0];
		GL_OUT = the_sel_i.geometricBounds[1];
		VL_OUT = the_sel_i.visibleBounds[1];
		GB_OUT = the_sel_i.geometricBounds[2];
		VB_OUT = the_sel_i.visibleBounds[2];
		GR_OUT = the_sel_i.geometricBounds[3];
		VR_OUT = the_sel_i.visibleBounds[3];
		G_OBJ_L =  G_OBJ_R = G_OBJ_T = G_OBJ_B = the_sel_i;
		V_OBJ_L = V_OBJ_R = V_OBJ_T = V_OBJ_B = the_sel_i;
		// цикл по объектам в выделении
		LOCKED = false;
		for( var i=0; i < sel_len; i++ ) {
			 the_sel_i = the_sel[i];
			 if( the_sel_i.locked) LOCKED = true;
			// top
			GT = the_sel_i.geometricBounds[0];
			VT = the_sel_i.visibleBounds[0];
			if( GT < GT_OUT ) { GT_OUT = GT; G_OBJ_T = the_sel_i }
			if( VT < VT_OUT ) { VT_OUT = VT; V_OBJ_T = the_sel_i }
			// left
			GL = the_sel_i.geometricBounds[1];
			VL = the_sel_i.visibleBounds[1];
			if( GL < GL_OUT ) { GL_OUT = GL; G_OBJ_L = the_sel_i }
			if( VL < VL_OUT ) { VL_OUT = VL; V_OBJ_L = the_sel_i }
			// bottom
			GB = the_sel_i.geometricBounds[2];
			VB = the_sel_i.visibleBounds[2];
			if( GB > GB_OUT ) { GB_OUT = GB; G_OBJ_B = the_sel_i }
			if( VB > VB_OUT ) { VB_OUT = VB; V_OBJ_B = the_sel_i }
			// right
			GR = the_sel_i.geometricBounds[3];
			VR = the_sel_i.visibleBounds[3];
			if( GR > GR_OUT ) { GR_OUT = GR; G_OBJ_R = the_sel_i }
			if( VR > VR_OUT ) { VR_OUT = VR; V_OBJ_R = the_sel_i }
		}// for
		// геометрические
		GT =GT_OUT;
		GL = GL_OUT;
		GB =GB_OUT;
		GR = GR_OUT;
		// визуальные
		VT = VT_OUT;
		VL = VL_OUT;
		VB = VB_OUT;
		VR = VR_OUT;
		// считаем центры
		GCH = GL + (GR - GL)/2.;
		GCV = GT + (GB - GT)/2.;
		VCH = VL + (VR - VL)/2.;
		VCV = VT + (VB - VT)/2.;
		 // считаем габариты
		GH = GR - GL;
		GV = GB - GT;
		VH = VR - VL;
		VV = VB - VT;
		// восстанавливаем старые коорд.
		RESTORE_PREFS();
		// spine
		if( AD.viewPreferences.rulerOrigin == RulerOrigin.spineOrigin ) {
			var AS = app.activeWindow.activeSpread;
			var PW = AD.documentPreferences.pageWidth;
			var ASP = AS.pages;
			var ASPN = AS.pages.length;
			var N_RIGHT_SIDE = -1;
			// определяем позицию начала правых страниц
			for(var i=0; i < ASPN; i++) {
				if( (ASP[i].side == PageSideOptions.rightHand) || (ASP[i].side == PageSideOptions.singleSided )) {
					N_RIGHT_SIDE = i;
					break;
				}// if
			}// for i
			// определяем положение центра и границ выделения левой и правой
			var NPG = 0;
			var NPV = 0;
			var NP_L_G = 0;
			var NP_L_V = 0;
			var NP_R_G = 0;
			var NP_R_V = 0;
			var P_LEFT=0;
			var P_RIGHT=0;
			for(var i=0; i < ASPN; i++) {
				P_LEFT = ASP[i].bounds[1];
				P_RIGHT = ASP[i].bounds[3];
				if( (GCH > P_LEFT ) && (GCH < P_RIGHT) ) {
					NPG = i;
				}// if
				if( (VCH > P_LEFT ) && (VCH < P_RIGHT ) ) {
					NPV = i;
				}// if
				if( (GL>P_LEFT) && (GL < P_RIGHT) )  NP_L_G = i;
				if( (VL>P_LEFT) && (VL < P_RIGHT) )  NP_L_V = i;
				if( (GR>P_LEFT) && (GR < P_RIGHT) )  NP_R_G = i;
				if( (VR>P_LEFT) && (VR < P_RIGHT) )  NP_R_V = i;
				if( i == (ASPN - 1)) {
					if( GR > P_RIGHT ) NP_R_G = i;
					if( VR > P_RIGHT ) NP_R_V = i;
					if( GL >P_RIGHT ) NP_L_G = i;
					if( VL > P_RIGHT ) NP_L_V = i;
					if( GCH > P_RIGHT ) NPG = i;
					if( VCH > P_RIGHT ) NPV = i;;
				}// if
			}// for 
			// определяем границы выделения из номера страницы
			// left
			if(N_RIGHT_SIDE > 0 ){
				var D_N = ASPN - N_RIGHT_SIDE;
				if( NP_L_G >= N_RIGHT_SIDE ) {
					GL = GL - PW*D_N;
				}
				if( NP_L_V >= N_RIGHT_SIDE ) {
					VL = VL - PW*D_N;
				}
				// right
				if( NP_R_G >= N_RIGHT_SIDE ) {
					GR = GR - PW*D_N;
				}
				if( NP_R_V >= N_RIGHT_SIDE ) {
					VR = VR - PW*D_N;
				}
				// center
				if( NPG >= N_RIGHT_SIDE ) {
					GCH = GCH - PW*D_N;
				}
				if( NPV >= N_RIGHT_SIDE ) {
					VCH = VCH - PW*D_N;
				}
				return;
			}// if
			// если все страницы на развороте левые
			// если выскочили за правый край самой правой страницы
			if( N_RIGHT_SIDE < 0 ){
				P_RIGHT = ASP[ASPN-1].bounds[3];
				DR = PW*ASPN;
				if( VL > P_RIGHT ) VL = VL - DR;
				if( GL > P_RIGHT ) GL = GL - DR;
				if( VR > P_RIGHT ) VR = VR - DR;
				if( GR > P_RIGHT ) GR = GR - DR;
				if( GCH > P_RIGHT ) GCH = GCH - DR;
				if( VCH > P_RIGHT ) VCH = VCH - DR;
			}// if
	return;
	}// is spine
		// spread
		 if( AD.viewPreferences.rulerOrigin == RulerOrigin.spreadOrigin ) {
			  return;
		};// if spread
		// page
		  if( AD.viewPreferences.rulerOrigin == RulerOrigin.pageOrigin ) {
			 // границы геом.
			GT = G_OBJ_T.geometricBounds[0];
			GL = G_OBJ_L.geometricBounds[1];
			GB = G_OBJ_B.geometricBounds[2];
			GR = G_OBJ_R.geometricBounds[3]; //alert(GR)
			// границы виз.
			VT = V_OBJ_T.visibleBounds[0];
			VL = V_OBJ_L.visibleBounds[1];
			VB = V_OBJ_B.visibleBounds[2];
			VR = V_OBJ_R.visibleBounds[3];
			
			var AS = app.activeWindow.activeSpread;
			var PW = AD.documentPreferences.pageWidth;
			var ASP = AS.pages;
			var ASPN = AS.pages.length;
			// если центр правее границы крайней правой стр.
			if(  (GCH > ASP[ASPN-1].bounds[3])  ) {
				GCH = GCH - PW*ASPN;
			}
			if(  (VCH > ASP[ASPN-1].bounds[3])  ) {
				VCH = VCH - PW*ASPN;
			}
			var NPG = 0;
			var NPV = 0;
			// на какую страницу приходится центр
			var P_LEFT, P_RIGHT
			var OK_G = false;
			var OK_V = false;
			var GR_1 = GR;
			var GL_1 = GL;
			var VR_1 = VR;
			var VL_1 = VL;
			var DR, N_DR
			for(var i=0; i < ASPN; i++) {
				P_LEFT = ASP[i].bounds[1];
				P_RIGHT = ASP[i].bounds[3];
				if( (!OK_G) && (GL < P_RIGHT) && (GR > P_RIGHT)) {
					DR = GR - P_RIGHT;
					N_DR = parseInt(DR/PW);
					GR_1 = GR - PW*(N_DR+1); OK_G = true;
				}
				if( (!OK_V) && (VL < P_RIGHT) && (VR > P_RIGHT)) {
					DR = VR - P_RIGHT;
					N_DR = parseInt(DR/PW);
					VR_1 = VR - PW*(N_DR+1); OK_V = true;
				}					
				if( (GCH > P_LEFT ) && (GCH < P_RIGHT) ) {
					NPG = i;
				}// if
				if( (VCH > P_LEFT ) && (VCH < P_RIGHT ) ) {
					NPV = i;
				}// if
			}// for
			// если центры на страницах
			if(  (GCH > ASP[0].bounds[1]) &&  (GCH < ASP[ASPN-1].bounds[3])  ) {
				GCH = GCH - PW*NPG;
			}
			if(  (VCH > ASP[0].bounds[1]) && (VCH < ASP[ASPN-1].bounds[3])  ) {
				VCH = VCH - PW*NPV;
			}
			GR = GR_1; VR = VR_1;
		return;
		};// if page
	} catch ( error) {
		EXIT_MESSAGE("Can not process the selection!");
	};// try-catch
}// end GET_SEL_BOUNDS
//
// подпрограмма установки версии для работы скрипта
function SET_VERSION() {
	// если версия InDesign выше CS2
	if( parseInt(app.version) > 5) app.scriptPreferences.version = 4;
return;
}// end SET_VERSION
//
// подпрограмма получения числа из текстового ввода
function GET_NUMBER( the_text ) {
	var t = "";
	var t_i;
	for(var i=0; i < the_text.length; i++) {
		t_i = the_text[i];
		if( t_i == "," ) t_i = ".";
		t = t + t_i;
	};// for
	t = parseFloat( t );
	if( isNaN(parseFloat(t) ) ) {
		EXIT_MESSAGE("Bad number input!");
	};// if
return t;
}// end GET_NUMBER
//
// подпрограмма проверки веделения 
function CHECK_SELECTION(){
	if( app.documents.length == 0 ) {
		EXIT_MESSAGE("There are no open documents!");
	};// if
	AD = app.activeDocument;
	the_sel = app.selection;
	sel_len = the_sel.length;
	if( sel_len <= 0 ) {
		EXIT_MESSAGE("There are no selected objects!");
	};// if
	if( the_sel[0].constructor.name == "Guide" ) {
		EXIT_MESSAGE("Guides are selected! Can not process this!");
	};// if
return;
}// end CHECK_SELECTION
//
// подпрограмма сохранения старых настроек документа
function SAVE_PREFS() {
	old_rulers = AD.viewPreferences.rulerOrigin;
	AD.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
	RULERS_WERE_CHANGED = true;
return;
};// end SAVE_PREFS
//
// подпрограмма восстановления старых настроек документа
function RESTORE_PREFS() {
	if( RULERS_WERE_CHANGED ) AD.viewPreferences.rulerOrigin = old_rulers;
	RULERS_WERE_CHANGED = false;
return;
};// end RESTORE_PREFS
//
// подпрограмма выхода и вывода сообщения
function EXIT_MESSAGE( msg ) {
	alert( msg );
	RESTORE_PREFS();
	exit();
};// end EXIT_MESSAGE